-- 7-Segement - Decoder
--
--   - a -
--  f     b
--   - g -
--  e     c
--   - d -   DP
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity HEX_7seg is
   port (
      In_HEX   : in  std_logic_vector(3 downto 0);
      LED_on   : in  std_logic;
      Out_7Seg : out std_logic_vector(7 downto 0)
   );
end HEX_7seg;


architecture Verhalten of HEX_7seg is
begin

process(In_HEX, LED_on)
begin

   case In_HEX is
      -- Segmentzuordnung:                  gfedcba
      when x"0" => Out_7Seg(6 downto 0) <= "0111111" ;  -- '0'
      when x"1" => Out_7Seg(6 downto 0) <= "0000110" ;  -- '1'
      when x"2" => Out_7Seg(6 downto 0) <= "1011011" ;  -- '2'
      when x"3" => Out_7Seg(6 downto 0) <= "1001111" ;  -- '3'
      when x"4" => Out_7Seg(6 downto 0) <= "1100110" ;  -- '4'
      when x"5" => Out_7Seg(6 downto 0) <= "1101101" ;  -- '5'
      when x"6" => Out_7Seg(6 downto 0) <= "1111101" ;  -- '6'
      when x"7" => Out_7Seg(6 downto 0) <= "0000111" ;  -- '7'
      when x"8" => Out_7Seg(6 downto 0) <= "1111111" ;  -- '8'
      when x"9" => Out_7Seg(6 downto 0) <= "1101111" ;  -- '9'
      when x"A" => Out_7Seg(6 downto 0) <= "1110111" ;  -- 'A'
      when x"B" => Out_7Seg(6 downto 0) <= "1111100" ;  -- 'b'
      when x"C" => Out_7Seg(6 downto 0) <= "0111001" ;  -- 'C'
      when x"D" => Out_7Seg(6 downto 0) <= "1011110" ;  -- 'd'
      when x"E" => Out_7Seg(6 downto 0) <= "1111001" ;  -- 'E'
      when x"F" => Out_7Seg(6 downto 0) <= "1110001" ;  -- 'F'
      --when others => null;
   end case;
end process;

end Verhalten;